/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.equivalencia;

import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.ParadaEquivalencia;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.service.ParadaEquivalenciaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarParadaEquivalenciaController")
@Scope("prototype")
public class EditarParadaEquivalenciaController extends MyGenericForwardComposer {

    @Autowired
    private ParadaEquivalenciaService paradaEquivalenciaService;
    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    private ParadaEquivalencia paradaEquivalencia;
    private MyListbox paradaEquivalenciaList;
    private static Logger log = Logger.getLogger(EditarParadaEquivalenciaController.class);
    private List<ComisionistaExterno> lsComisionistaExterno;
    private Combobox cmbParada;
    private Combobox cmbComissionestaExterno;
    private Textbox txtEquivalencia;
    private Button btnApagar;

    public ParadaEquivalencia getParadaEquivalencia() {
        return paradaEquivalencia;
    }

    public void setParadaEquivalencia(ParadaEquivalencia paradaEquivalencia) {
        this.paradaEquivalencia = paradaEquivalencia;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Combobox getCmbParada() {
        return cmbParada;
    }

    public void setCmbParada(Combobox cmbParada) {
        this.cmbParada = cmbParada;
    }

    public List<ComisionistaExterno> getLsComisionistaExterno() {
        return lsComisionistaExterno;
    }

    public void setLsComisionistaExterno(List<ComisionistaExterno> lsComisionistaExterno) {
        this.lsComisionistaExterno = lsComisionistaExterno;
    }

    public Combobox getCmbComissionestaExterno() {
        return cmbComissionestaExterno;
    }

    public void setCmbComissionestaExterno(Combobox cmbComissionestaExterno) {
        this.cmbComissionestaExterno = cmbComissionestaExterno;
    }

    public Textbox getTxtEquivalencia() {
        return txtEquivalencia;
    }

    public void setTxtEquivalencia(Textbox txtEquivalencia) {
        this.txtEquivalencia = txtEquivalencia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsComisionistaExterno = comisionistaExternoService.obtenerTodos();

        super.doAfterCompose(comp);

        paradaEquivalencia = (ParadaEquivalencia) Executions.getCurrent().getArg().get("paradaEquivalencia");
        paradaEquivalenciaList = (MyListbox) Executions.getCurrent().getArg().get("paradaEquivalenciaList");

        if (paradaEquivalencia.getParadaequivalenciaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            Parada parada = paradaEquivalencia.getParada();
            if (parada != null) {
                cmbParada.setText(parada.getDescparada());
            }
            cmbParada.setDisabled(true);
            cmbComissionestaExterno.setDisabled(true);
        }

        cmbParada.setFocus(true);
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        cmbComissionestaExterno.getSelectedItem();
        cmbParada.getSelectedItem();
        txtEquivalencia.getText();

        try {

            ComisionistaExterno comisionistaExterno = paradaEquivalencia.getComisionistaExterno();
            Comboitem cbiParada = cmbParada.getSelectedItem();
            Parada parada = null;
            if (cbiParada != null) {
                paradaEquivalencia.setParada((Parada) cbiParada.getValue());
            }
            String equivalencia = paradaEquivalencia.getEquivalenciaId();

            List<ParadaEquivalencia> lsParadaEquivalente =
                    paradaEquivalenciaService.buscar(parada, comisionistaExterno,
                    equivalencia);

            boolean podeSalvar = false;
            if (lsParadaEquivalente.isEmpty()) {
                podeSalvar = true;
            } else {
                if (paradaEquivalencia.getParadaequivalenciaId() != null) {
                    for (ParadaEquivalencia p : lsParadaEquivalente) {
                        if (p.getParadaequivalenciaId().equals(paradaEquivalencia.getParadaequivalenciaId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }

            List<ParadaEquivalencia> lsEquivalente =
                    paradaEquivalenciaService.buscarEquivalencia(equivalencia);

            boolean podeSalvarEquivalencia = false;
            if (lsEquivalente.isEmpty()) {
                podeSalvarEquivalencia = true;
            } else {
                if (paradaEquivalencia.getParadaequivalenciaId() != null) {
                    for (ParadaEquivalencia p : lsEquivalente) {
                        if (p.getParadaequivalenciaId().equals(paradaEquivalencia.getParadaequivalenciaId())) {
                            podeSalvarEquivalencia = true;
                        }
                    }
                }
            }

            if (!podeSalvarEquivalencia) {
                Messagebox.show(
                        Labels.getLabel("MSG.Equivalencia.Existe"),
                        Labels.getLabel("editarParadaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }

            if (podeSalvar) {

                if (paradaEquivalencia.getParadaequivalenciaId() == null) {
                    paradaEquivalenciaService.suscribir(paradaEquivalencia);
                    paradaEquivalenciaList.addItem(paradaEquivalencia);
                } else {
                    paradaEquivalenciaService.actualizacion(paradaEquivalencia);
                    paradaEquivalenciaList.updateItem(paradaEquivalencia);
                }
                Messagebox.show(
                        Labels.getLabel("editarParadaEquivalenciaController.MSG.suscribirOK"),
                        Labels.getLabel("editarParadaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarParadaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error(ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarParadaEquivalenciaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);

        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarParadaEquivalenciaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarParadaEquivalenciaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                paradaEquivalenciaService.borrar(paradaEquivalencia);

                Messagebox.show(
                        Labels.getLabel("editarParadaEquivalenciaController.MSG.borrarOK"),
                        Labels.getLabel("editarParadaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                paradaEquivalenciaList.removeItem(paradaEquivalencia);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
